----------------------------------------------------------------------
----------
0. Introduction
----------
These are programs of the procedures shown in

	K. Kanatani, Y. Sugaya, and Y. Kanazawa,
	Ellipse Fitting for Computer Vision:
	Implementation and Applications,
	Morgan & Claypool Publishers, 2016.

	ISBN: 9781627054584  paperback
	ISBN: 9781627054980  ebook

----------
1. Required
----------
These programs required the following libraries:

	Eigen3
	OpenCV 2.4

Before compiling our programs, please install these libraries.

Note: OpenCV is only used for displaying and manipulating images.  If
you want only mathematical computations shown in our book, you need
not install OpenCV.

----------
2. Check Environment
----------
We are tested these programs on the following environment:

	Debian GNU/Linux 8.6 (Jessie)
	Eigen3 (eigen-eigen-bdd17ee3b1b3)
	OpenCV (2.4.9)
	C++ (gcc version 4.9.2 (Debian 4.9.2-10))

----------
3. Directories
----------
The following directories are included:

	``srcs'' include the source files of the procedures.
	``check'' include check programs.

----------
4. Compile
----------
We prepare very simple Makefiles, so, in many cases, you just hit in
the top directory.

	$ make

Then, you can get libraries.  But, in some cases, you need to modify
Makefile(s) in top and sub directories.

----------
5. List of procedures
----------
Corresponding between each file and procedure are:

	Procedure 1.1:  least_squares.cc
	Procedure 2.1:  iterative_reweight.cc
	Procedure 2.2:  renormalizatin.cc
	Procedure 2.3:  hyper_renormalization.cc
	Problem 2.1:	taubin.cc
	Problem 2.2:	hyperls.cc
	Procedure 3.1:  fns.cc
	Procedure 3.2:  geometric_distance_minimization.cc
	Procedure 3.3:  hyperaccurate_correction.cc
	Procedure 4.1:  ransac.cc
	Procedure 4.2:  fitzgibbon.cc
	Procedure 4.3:  random_sampling.cc
	Procedure 5.1:  ellipse_intersectinos.cc
	Procedure 5.2:  perpendicular_to_ellipse.cc
	Procedure 5.3:  supporting_plane_reconstruction.cc
	Procedure 5.4:  center_of_circle.cc
	Procedure 5.5:  front_image_of_the_circle.cc

----------
*. Acknowledgments
----------
We thank T. Nishimura and M. Matsumoto.  In our program, we use their
excellent code of Mersenne Twister, which is an famous algorithm to
generate random numbers.

----------
**. Version
----------
	Version 0.4:	June 26, 2017.
	Version 0.3:	Dec. 14, 2016.
	Version 0.2:	Dec. 13, 2016.
	Version 0.1:	April 23, 2016.

----------
***. Contact
----------
These programs are cheked using some data, but they may include some
bugs and problems.  If you find any problems, please send E-mail to

	kanazawa@cs.tut.ac.jp
		or
	sugaya@cs.tut.ac.jp
----------------------------------------------------------------------
